
provider "docker" {
  host = "tcp://${var.ssh_host}:2375"
}

resource "docker_network" "tips-of-mine" {
  name = "mynet1"
  driver = "bridge"
  ipam_config {
    subnet = "10.0.5.0/24"
  }
}

resource "docker_image" "nginx" {
  name = "nginx:latest"
}

resource "docker_container" "nginx" {
  image = docker_image.nginx.latest
  name  = "enginecks"
  ports {
    internal = 80
    external = 80
  }
  networks_advanced {
    name = docker_network.tips-of-mine.name
  }
}
